<template>
    <BasicTable @register="registerTable">
      <template #toolbar>
        <a-button type="primary" @click="exportExcel" v-if="getCheckPerm('download-order-export')"> 导出</a-button>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'action'">
          <TableAction
            stopButtonPropagation
            :actions="[
              {
                label: '删除',
                //icon: 'ic:outline-delete-outline',
                onClick: handleDelete.bind(null, record),
              },
            ]"
            :dropDownActions="[
              {
                label: '启用',
                popConfirm: {
                  title: '是否启用？',
                  confirm: handleOpen.bind(null, record),
                },
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
</template>
<script lang="ts">
  import { defineComponent, h, ref } from 'vue';
  import { BasicTable, useTable, TableAction, BasicColumn, TableImg, FormProps } from '/@/components/Table';
  import { PageWrapper } from '/@/components/Page';
  import { Time } from '/@/components/Time';
  import { Descriptions } from 'ant-design-vue';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { DownList,DownExport } from '/@/api/order'
  import {  downloadByData, } from '/@/utils/file/download';
  import { usePermissionStore } from '/@/store/modules/permission';
  import { dowmColumns,equitySearchForm } from '../account/details/data'

  export default defineComponent({
    components: { 
      BasicTable, 
      TableAction, 
      PageWrapper,
      TableImg,
      [Descriptions.name]: Descriptions,
      [Descriptions.Item.name]: Descriptions.Item,
    },
    setup() {
      const { t } = useI18n();
      const isSearch = ref(false)
      const { createConfirm } = useMessage();
      const permissionStore = usePermissionStore();
      const { getCheckPerm } = permissionStore;
      const [registerTable] = useTable({
        api: DownList,
        title: '下载列表',
        // titleHelpMessage: ['已启用expandRowByClick', '已启用stopButtonPropagation'],
        columns: dowmColumns,
        useSearchForm: true,
        formConfig: equitySearchForm,
        showTableSetting: true,
        showIndexColumn:false,
        rowKey: 'id',
        beforeFetch:(T)=>{
          const {ctivated,tradeNum,userName,orderSn} = T
          if(ctivated||tradeNum||userName||orderSn){
            isSearch.value = true
          }else{
            isSearch.value = false
          }
          if(T.ctivated){
            T.startTime = T.ctivated[0]
            T.endTime = T.ctivated[1]
          }
          return T
        },
        fetchSetting: {
          pageField: 'pageNum',
          sizeField: 'pageSize',
          listField: 'list',
          totalField: 'total',
        },
        canResize: true,
      });
      function handleDelete(record: Recordable) {
        console.log('点击了删除', record);
      }
      function handleOpen(record: Recordable) {
        console.log('点击了启用', record);
      }
      function exportExcel() {
        createConfirm({
          iconType: 'warning',
          title: () => h('span', '温馨提示'),          
          content: () => h('span', isSearch.value?'确认导出搜索结果？':'确认导出全部?'),
          onOk: async () => {
            DownExport()
          },
        });
      }
      return {
        registerTable,
        handleDelete,
        handleOpen,
        exportExcel,
        getCheckPerm,
      };
    },
  });
</script>